# evac.rb -- ITS Evacuated File Format
#
# Written 010805 by Mirian Crzig Lennox
# Copyright (c) 2001, released under the terms of the GNU Public License

require "cosmic"
require "pdp10"

module PDP10
  module Evac

    def conv_ascii c
      case c
      when 0..011,013,014,016..0176 then [c]
      when 012 then [015, 012]
      when 015 then [012]
      when 0177 then [0177, 07]
      when 0200..0206,0210,0211,0213,0214,0216..0355 then [0177, (c-0200)]
      when 0207 then [0177, 0177]
      when 0212 then [0177, 015]
      when 0215 then [0177, 012]
      when 0356 then [015]
      when 0357 then [0177]
      else nil
      end
    end

    def read_buffer
      charbuf = []
      wordbuf = []
      bytebuf = []
      while (inbyte = getc)
	if (bytebuf.length > 0)
	  bytebuf.push(inbyte)
	  if (bytebuf.length == 5)
	    wordbuf.push(splice(bytebuf, 4, 8, 8, 8, 8))
	    bytebuf = []
	  end
	else
	  if (chars = conv_ascii(inbyte))
	    chars.each do |c|
	      charbuf.push c
	      if charbuf.length == 5
		wordbuf.push(splice(charbuf, 7, 7, 7, 7, 7, 1))
		charbuf = []
	      end
	    end
	  else
	    bytebuf = [inbyte & 017]
	  end
	end
      end
      return wordbuf
    end
  end
end
