# pdp10.rb -- General PDP10 support routines
#
# Written 010801 by Mirian Crzig Lennox
# Copyright (c) 2001, released under the terms of the GNU Public License

require "cosmic"

module PDP10
  def jrst a18
    0254000000000 | (a18 & 0777777)
  end

  def aobjn count, addr
    (((01000000 - (count & 0777777))) << 18) | ((addr - 1) & 0777777)
  end

  def add36 word1, word2
    (word1 + word2) & 0777777777777
  end

  def compl36 word
    (01000000000000 - (word & 0777777777777)) & 0777777777777
  end

  def to_sixbit s
    splice((s.upcase.unpack("c*").collect{|c| c - 040}),6,6,6,6,6,6)
  end

  def from_sixbit n
    (shred(n,6,6,6,6,6,6).collect{|c| c + 040}).pack("c6").upcase
  end

  def its2unix(itsroot,dir,fn1,fn2)
    dir = dir.downcase.tr('.','_')
    fn1 = fn1.downcase.tr('.','_')
    fn2 = fn2.downcase.tr('.','_')
    path = itsroot + "/" + dir + "/" + fn1 + "."
    if (fn2 == '>')
      path = Dir[path+"[0-9]*"].sort.pop
      if path =~ /\.([0-9]*)$/
	fn2 = $1
      end
    else
      path += fn2
    end
    [path,fn2]
  end

end
